/*
 * PIMPPA: Bowser
 *
 */

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "proto.h"
#include "../src/pimppa.h"

MYSQL db;
GtkWidget *Bowser;
GnomeClient *Client;

void zombie_handler(int sig)
{
	while ((waitpid(-1, NULL, WNOHANG)) > 0);
}

/*the save_yourself handler, you can safely ignore most of the
   parameters, and just save your session and return TRUE*/
int 
save_yourself(void)
{
	gint x=0, y=0, w=0, h=0;
    char *prefix= gnome_client_get_config_prefix (Client);
	
//	fprintf(stderr, "DEBUG: save_yourself()\n");

    /*get the prefix for our config*/

    /* Save the state using gnome-config stuff. */
    gnome_config_push_prefix (prefix);
  
	gdk_window_get_position(Bowser->window, &x, &y);
	
	gdk_window_get_size(Bowser->window, &w, &h);

//	printf("Save: %d %d %d %d\n", x, y, w, h);

	gnome_config_set_int ("Geometry/x", x);
	gnome_config_set_int ("Geometry/y", y);
	gnome_config_set_int ("Geometry/w", w);
	gnome_config_set_int ("Geometry/h", h);
         
	gnome_config_pop_prefix ();
    gnome_config_sync();

    return TRUE;
}

static void 
restore_yourself(void) 
{
	gint x=0, y=0, w=0, h=0;
	
//	fprintf(stderr, "DEBUG: restore_yourself()\n");

	gnome_config_push_prefix
		(gnome_client_get_config_prefix (Client));

	x=gnome_config_get_int("Geometry/x");
	y=gnome_config_get_int("Geometry/y");
	w=gnome_config_get_int("Geometry/w");
	h=gnome_config_get_int("Geometry/h");  
 
//	printf("Load: %d %d %d %d\n", x, y, w, h);
 
	gnome_config_pop_prefix ();

/*
	if ((w!=0) && (h!=0)) 
		gtk_widget_set_usize(GTK_WIDGET(Bowser),w,h);
	else
*/
	gtk_widget_set_usize(GTK_WIDGET(Bowser),640,480);

	if ((x!=0) && (y!=0)) 
		gtk_widget_set_uposition(GTK_WIDGET(Bowser),x,y);
}

static gint
delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	gtk_main_quit();
	mysql_close(&db);
	
	return FALSE;
}

int main(int argc, char *argv[])
{
	GtkWidget *vbox;

/************ Connect the gnome stuff ***************/

	gnome_init("bowser", VERSION, argc, argv);
	Bowser=gnome_app_new("bowser", "PIMPPA bowser");
	gtk_signal_connect(GTK_OBJECT(Bowser), "delete_event",
						GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_signal_connect(GTK_OBJECT(Bowser), "destroy",
						GTK_SIGNAL_FUNC(delete_event), NULL);
	
	Client=gnome_master_client();
	gtk_signal_connect (GTK_OBJECT (Client), "save_yourself",
						GTK_SIGNAL_FUNC (save_yourself),
						NULL);
	gtk_signal_connect (GTK_OBJECT (Client), "die",
						GTK_SIGNAL_FUNC (delete_event), NULL);

	if (GNOME_CLIENT_CONNECTED (Client)) 
		restore_yourself();

/******** Connect the MySQL server *********/

	mysql_connect(&db, NULL, P_USER, NULL);
	if(mysql_error(&db)[0])
	{
		my_error_dialog("%s\n", mysql_error(&db));
		return(-1);
	}
	mysql_select_db(&db, P_DBASE);
	if(mysql_error(&db)[0])
	{
		my_error_dialog("%s\n", mysql_error(&db));
		mysql_close(&db);
		return(-1);
	}	

/********** Zombie handler **************/

	signal(SIGCHLD,zombie_handler);

/********** Ok, lets do some GUI shit ***********/

	create_menus();
    
/****** Main stuff page ***********/

//	vbox=test();

	vbox=get_stuff_box();
//    label = gtk_label_new("Stuff");
    
	gnome_app_set_contents ( GNOME_APP (Bowser), vbox);

/****** Newsgroups page ***********/
	
//	vbox=get_groups_box();
//	label=gtk_label_new("Newsgroups");
//    gtk_notebook_append_page(GTK_NOTEBOOK (notebook), vbox, label);



/****** Types page ****************/

//	vbox=get_types_box();
//	label=gtk_label_new("Filetypes");
//    gtk_notebook_append_page(GTK_NOTEBOOK (notebook), vbox, label);

/****** Assigns page **************/

//	vbox=get_assigns_box();
//	label = gtk_label_new("Assigns");
//    gtk_notebook_append_page(GTK_NOTEBOOK (notebook), vbox, label);

//	gtk_notebook_set_page (GTK_NOTEBOOK(notebook), 0);

	gtk_widget_show_all(Bowser);

	gtk_main();

	mysql_close(&db);
		 
	return(0);
}


